<?php

include_once '../WordpressPaymentMailNotification.php';
include_once '../shop_plugins/class-wc-gateway-ubrr.php';
include_once '../WordpressUBRiRConnector.php';

class WooCommerceUBRIRCallback extends \UBRIR\CMS_PaymentCallback
{
    public function BeforeSendMailNotification(\UBRIR\PaymentResultViewer $resultViewer)
    {
        $wp_order_info = wc_get_order($resultViewer->GetOrderId());
        $email = $wp_order_info->data['billing']['email'];

        $this->SetMailReceivers($email);

        return $resultViewer;
    }

    public function OnPaymentApproved($shopOrderId, $sessionId)
    {
        $wp_order_info = wc_get_order($shopOrderId);
        $wp_order_info->update_status(get_option('ubrr_payment_setting_approved_woo'));

        $orderStatus = $this->callbackDataContainer->getFieldValue('OrderStatus');
        $continueLink = wc_get_page_permalink('order-received');

        return $continueLink;
    }

    public function OnPaymentCanceled($shopOrderId, $sessionId)
    {
        $wp_order_info = wc_get_order($shopOrderId);
        $wp_order_info->update_status(get_option('ubrr_payment_setting_canceled_woo'));

        return false;
    }

    public function OnPaymentDeclined($shopOrderId, $sessionId)
    {
        $wp_order_info = wc_get_order($shopOrderId);
        $wp_order_info->update_status(get_option('ubrr_payment_setting_declined_woo'));

        return false;
    }
}

$wordpressMailNotification = new WordpressPaymentMailNotification();

$Connector = new WordpressUBRiRConnector();
$WooCommerceCallbackHandler = new WooCommerceUBRIRCallback($Connector);
$WooCommerceCallbackHandler
    ->ActivatePaymentMailNotification($wordpressMailNotification)
    ->ProcessCallbackResponse()
    ->ShowCallbackProcessResult();