<?php
include_once $_SERVER['DOCUMENT_ROOT'].'/wp-load.php';

add_filter(
    'wpsc_purchase_log_customer_notification_raw_message',
    '_wpsc_filter_ubrr_customer_notification_raw_message',
    10,
    2
);

add_filter(
    'wpsc_purchase_log_customer_html_notification_raw_message',
    '_wpsc_filter_ubrr_customer_notification_raw_message',
    10,
    2
);

$user_info = get_userdata(1);
if ($user_info->user_level >= 8) {
    $nzshpcrt_gateways[$num] = array(
        'name' => __('УБРиР', 'wp-e-commerce'),
        'api_version' => 2.0,
        'class_name' => 'wpsc_merchant_ubrr',
        'has_recurring_billing' => true,
        'display_name' => __('УБРиР', 'wp-e-commerce'),
        'wp_admin_cannot_cancel' => false,
        'requirements' => array(
            /// so that you can restrict merchant modules to PHP 5, if you use PHP 5 features
            ///'php_version' => 5.0,
        ),

        'form' => 'form_ubrr',
        'internalname' => 'wpsc_merchant_ubrr',
        'payment_type' => 'ubrr',
    );
    $image = apply_filters('wpsc_merchant_image', '', $nzshpcrt_gateways[$num]['internalname']);
    if (!empty($image)) {
        $nzshpcrt_gateways[$num]['image'] = $image;
    }
}

class wpsc_merchant_ubrr extends wpsc_merchant
{
    var $name = '';

    function __construct($purchase_id = null, $is_receiving = false)
    {
        $this->name = __('УБРиР', 'wp-e-commerce');
        parent::__construct($purchase_id, $is_receiving);
    }

    function submit()
    {
        $this->set_purchase_processed_by_purchid(get_option('ubrr_payment_setting_init_ecom'));
        $ecomSessionID = $this->cart_data['session_id'];
        $amount = $this->cart_data['total_price'];

        if (get_option('post_payment')) {
            $redirect_url = get_site_url() . '/wp-content/plugins/ubrr/postpayment/ecom-choose.php?id=' . $ecomSessionID . '&amount=' . $amount;
            wp_redirect($redirect_url, 301);
            die();
        } else {
            require_once($_SERVER['DOCUMENT_ROOT'] . '/wp-load.php');

            include_once $_SERVER['DOCUMENT_ROOT'] . '/wp-content/plugins/ubrr/Wordpress.php';
            $cmsModule = new UBRIR\Wordpress();
            //Переход после оплаты

            $site_url = get_site_url();
            $callbackURL = $site_url . '/wp-content/plugins/ubrr/callback/ecom_callback.php';

            //Подготавливаем почву для оплаты
            global $wpdb;
            $orderIdDb = $wpdb->prepare("SELECT * FROM `" . WPSC_TABLE_PURCHASE_LOGS . "` WHERE `sessionid`= %s LIMIT 1", $ecomSessionID);
            $rows = $wpdb->get_results($orderIdDb, ARRAY_A);
            $orderId = $rows[0]['id'];
            $response = $cmsModule->SetupAndPrepareToPay($orderId, $amount, $callbackURL);

            //Проверка связи с сервером
            if ($response->isSuccess()) {
                $TWPG_OrderId = $response->GetTWPG_OrderId();
                $SessionId = $response->GetSessionId();

                $cmsModule->SaveTWPGOrder($orderId, $TWPG_OrderId, $SessionId); //, $ecomSessionID

                $redirect_url = $response->GetPaymentUrl($TWPG_OrderId, $SessionId);
                //очистка корзины
                global $wpsc_cart;
                $wpsc_cart->empty_cart();
                wp_redirect($redirect_url, 301);
                die();

            } else {
                //Не удалось подготовиться как следует
                $cmsModule->ShowPaymentError(false, false);
            }

        }

    }

}

function form_ubrr()
{
    $output = "
		<tr>
			<td>
				" . __('Сообщение после заказа', 'wp-e-commerce') . "
			</td>
			<td>
				<textarea cols='40' rows='9' name='wpsc_options[payment_instructions]'>" . esc_textarea(get_option('payment_instructions')) . "</textarea><br />
			</td>
		</tr>\n";

    return $output;
}

function _wpsc_filter_ubrr_customer_notification_raw_message($message, $notification)
{
    return $_GET['sessionid'];
}






