<?php
/**
 * Plugin Name: UBRR
 * Plugin URI: http://ubrr.ru/
 * Description: Payment module.
 * Version: 1.0.0
 * Author: I-SYS
 * Author URI: https://i-sys.ru
 * Requires at least: 4.4
 * Tested up to: 4.7
 *
 * Text Domain: ubrr
 * Domain Path: /i18n/languages/
 *
 * @package UBRR
 * @category Core
 * @author I-SYS
 */
if (!class_exists('\UBRIR\Wordpress'))
    include 'Wordpress.php';

\UBRIR\Wordpress::Init();

add_action('admin_menu', 'ubrr_add_admin_pages');

register_activation_hook(__FILE__, 'ubrr_activate');
register_deactivation_hook(__FILE__, '\UBRIR\Wordpress::DeactivatePlugin');

//TODO: вынести в инициализацию интеграции с WPShop, и повторять регистрацию фильтра только если интеграция настроена
include_once 'shop_plugins_init/wpshop_init.php';
add_filter('wpshop_add_payment_ubrr', 'wpshop_add_payment');

function ubrr_activate()
{
    \UBRIR\Wordpress::ActivatePlugin();
    $wp = new \UBRIR\Wordpress(false);
    $wp->RegisterWPOptions();
}

function ubrr_add_admin_pages()
{
    //Создаем ссылку в меню Wordpress
    add_menu_page('УБРиР',
        'Интеграция с УБРиР',
        8,
        'ubrr',
        'ubrr_options_page',
        '/wp-content/plugins/ubrr/ubrr.svg',
        1);
}

function ubrr_options_page()
{
    //Инициализируем настройки плагина в БД

    //Выводим форму настроек
    $wp_ubrr = new UBRIR\Wordpress(false);

    //Обновление настроек из формы (если были переданы)
    $wp_ubrr->UpdateSettings();
    $wp_ubrr->UpdateShopSettings();
    $wp_ubrr->UpdateNotificationsSettings();
    $wp_ubrr->ShowSettingsPage();
}


